summaryrefslogtreecommitdiffstats
path: root/package/base-files
diff options
context:
space:
mode:
authormbm <mbm@3c298f89-4303-0410-b956-a3cf2f4a3e73>2007-05-10 14:37:47 +0000
committermbm <mbm@3c298f89-4303-0410-b956-a3cf2f4a3e73>2007-05-10 14:37:47 +0000
commitde0bb1d6c480b2945cf25f80116d963b22dd3c7a (patch)
tree0d8ea6a346ce1aed9ac866ebb526f81832423ec0 /package/base-files
parentc5eea72dc54a79a3375fa7e9cf560ba757e01147 (diff)
unified preinit environment
git-svn-id: svn://svn.openwrt.org/openwrt/trunk@7173 3c298f89-4303-0410-b956-a3cf2f4a3e73
Diffstat (limited to 'package/base-files')
-rwxr-xr-xpackage/base-files/files/bin/firstboot4
-rw-r--r--package/base-files/files/etc/diag.sh5
-rwxr-xr-xpackage/base-files/files/etc/init.d/done15
-rwxr-xr-xpackage/base-files/files/etc/preinit14
-rwxr-xr-xpackage/base-files/files/sbin/mount_root22
5 files changed, 52 insertions, 8 deletions
diff --git a/package/base-files/files/bin/firstboot b/package/base-files/files/bin/firstboot
index ef2ba5733..267e6732d 100755
--- a/package/base-files/files/bin/firstboot
+++ b/package/base-files/files/bin/firstboot
@@ -79,8 +79,6 @@ ramoverlay() {
}
[ "$1" = "switch2jffs" ] && {
- mtd erase "$partname"
-
# try to avoid fs changing while copying
mount -o remount,ro none / 2>&-
@@ -103,8 +101,6 @@ ramoverlay() {
# this will almost always fail
umount /tmp/root 2>&-
- # fs is clean
- jffs2root --clean
exit 0
}
diff --git a/package/base-files/files/etc/diag.sh b/package/base-files/files/etc/diag.sh
new file mode 100644
index 000000000..7ecb7330f
--- /dev/null
+++ b/package/base-files/files/etc/diag.sh
@@ -0,0 +1,5 @@
+#!/bin/sh
+# Copyright (C) 2006 OpenWrt.org
+
+set_state() {
+}
diff --git a/package/base-files/files/etc/init.d/done b/package/base-files/files/etc/init.d/done
new file mode 100755
index 000000000..0640b6193
--- /dev/null
+++ b/package/base-files/files/etc/init.d/done
@@ -0,0 +1,15 @@
+#!/bin/sh /etc/rc.common
+# Copyright (C) 2006 OpenWrt.org
+
+START=95
+boot() {
+ [ -d /tmp/root ] && {
+ lock /tmp/.switch2jffs
+ firstboot switch2jffs
+ lock -u /tmp/.switch2jffs
+ }
+
+ # set leds to normal state
+ . /etc/diag.sh
+ set_state done
+}
diff --git a/package/base-files/files/etc/preinit b/package/base-files/files/etc/preinit
index c60a0f850..b23508f55 100755
--- a/package/base-files/files/etc/preinit
+++ b/package/base-files/files/etc/preinit
@@ -1,6 +1,20 @@
#!/bin/sh
# Copyright (C) 2006 OpenWrt.org
export PATH=/bin:/sbin:/usr/bin:/usr/sbin
+. /etc/diag.sh
+
+failsafe() {
+ lock /tmp/.failsafe
+ ash --login
+}
+
[ -e /etc/preinit.arch ] && . /etc/preinit.arch
+
+set_state preinit
+
mount_root ${FAILSAFE:+failsafe}
+
+eval ${FAILSAFE:+failsafe}
+lock -w /tmp/.failsafe
+
exec /sbin/init
diff --git a/package/base-files/files/sbin/mount_root b/package/base-files/files/sbin/mount_root
index 607c79968..a783f3d8f 100755
--- a/package/base-files/files/sbin/mount_root
+++ b/package/base-files/files/sbin/mount_root
@@ -3,9 +3,10 @@
. /etc/functions.sh
mount none /proc -t proc
-size=$(awk '/Mem:/ {l=5242880;print((s=$2/2)<l)?$2-l:s}' /proc/meminfo)
+size=$(awk '/MemTotal:/ {l=5242880;mt=($2*1024);print((s=mt/2)<l)?mt-l:s}' /proc/meminfo)
mount none /tmp -t tmpfs -o size=$size,nosuid,nodev,mode=1777
+
if grep devfs /proc/filesystems >/dev/null; then
mount none /dev -t devfs
else
@@ -13,7 +14,9 @@ else
mknod /dev/console c 5 1
exec >/dev/console </dev/console 2>&1
fi
+
mkdir /dev/shm
+
if grep sysfs /proc/filesystems >/dev/null; then
mount -t sysfs none /sys
HOTPLUG=""
@@ -27,14 +30,25 @@ echo "$HOTPLUG" > /proc/sys/kernel/hotplug
mkdir -p /dev/pts
mount none /dev/pts -t devpts
+jffs2_ready () {
+ mtdpart="$(find_mtd_part rootfs_data)"
+ magic=$(hexdump $mtdpart -n 4 -e '4/1 "%02x"')
+ [ "$magic" != "deadc0de" ]
+}
+
[ failsafe != "$1" ] && {
grep rootfs /proc/mtd >/dev/null 2>/dev/null && {
mtd unlock rootfs
grep rootfs_data /proc/mtd >/dev/null 2>/dev/null && {
. /bin/firstboot
- echo "switching to jffs2"
- mount "$(find_mtd_part rootfs_data)" /jffs -t jffs2
- fopivot /jffs /rom
+ jffs2_ready && {
+ echo "switching to jffs2"
+ mount "$(find_mtd_part rootfs_data)" /jffs -t jffs2
+ fopivot /jffs /rom
+ } || {
+ echo "jffs2 not ready yet; using ramdisk"
+ ramoverlay
+ }
}
} || mount -o remount,rw /dev/root /
}